    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * LegendItemCollection.java
    029     * -------------------------
    030     * (C) Copyright 2002-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: LegendItemCollection.java,v 1.4.2.1 2005/10/25 16:50:20 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 07-Feb-2002 : Version 1 (DG);
    040     * 24-Sep-2002 : Added get(int) and getItemCount() methods (DG);
    041     * 02-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    042     * 18-Apr-2005 : Added equals() method and implemented Cloneable and
    043     *               Serializable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart;
    048
    049    import java.io.Serializable;
    050    import java.util.Iterator;
    051    import java.util.List;
    052
    053    /**
    054     * A collection of legend items.
    055     */
    056    public class LegendItemCollection implements Cloneable, Serializable {
    057
    058        /** For serialization. */
    059        private static final long serialVersionUID = 1365215565589815953L;
    060
    061        /** Storage for the legend items. */
    062        private List items;
    063
    064        /**
    065         * Constructs a new legend item collection, initially empty.
    066         */
    067        public LegendItemCollection() {
    068            this.items = new java.util.ArrayList();
    069        }
    070
    071        /**
    072         * Adds a legend item to the collection.
    073         *
    074         * @param item  the item to add.
    075         */
    076        public void add(LegendItem item) {
    077            this.items.add(item);
    078        }
    079
    080        /**
    081         * Adds the legend items from another collection to this collection.
    082         *
    083         * @param collection  the other collection.
    084         */
    085        public void addAll(LegendItemCollection collection) {
    086            this.items.addAll(collection.items);
    087        }
    088
    089        /**
    090         * Returns a legend item from the collection.
    091         *
    092         * @param index  the legend item index (zero-based).
    093         *
    094         * @return The legend item.
    095         */
    096        public LegendItem get(int index) {
    097            return (LegendItem) this.items.get(index);
    098        }
    099
    100        /**
    101         * Returns the number of legend items in the collection.
    102         *
    103         * @return The item count.
    104         */
    105        public int getItemCount() {
    106            return this.items.size();
    107        }
    108
    109        /**
    110         * Returns an iterator that provides access to all the legend items.
    111         *
    112         * @return An iterator.
    113         */
    114        public Iterator iterator() {
    115            return this.items.iterator();
    116        }
    117
    118        /**
    119         * Tests this collection for equality with an arbitrary object.
    120         *
    121         * @param obj  the object (<code>null</code> permitted).
    122         *
    123         * @return A boolean.
    124         */
    125        public boolean equals(Object obj) {
    126            if (obj == this) {
    127                return true;
    128            }
    129            if (!(obj instanceof LegendItemCollection)) {
    130                return false;
    131            }
    132            LegendItemCollection that = (LegendItemCollection) obj;
    133            if (!this.items.equals(that.items)) {
    134                return false;
    135            }
    136            return true;
    137        }
    138
    139        /**
    140         * Returns a clone of the collection.
    141         *
    142         * @return A clone.
    143         *
    144         * @throws CloneNotSupportedException if an item in the collection is not
    145         *         cloneable.
    146         */
    147        public Object clone() throws CloneNotSupportedException {
    148            return super.clone();
    149        }
    150
    151    }